/*
  LiquidCrystal Library - Hello World
 
 Demonstrates the use a 16x2 LCD display.  The LiquidCrystal
 library works with all LCD displays that are compatible with the 
 Hitachi HD44780 driver. There are many of them out there, and you
 can usually tell them by the 16-pin interface.
 
 Ce programme gère l'affichage de la bobineuse et la gestion moteur
 Affiche sur l'écran LCD le nombre de spires
 Gère l'avance du moteur pàp en fonction du diamètre
 
  Le circuit:
 * ILS 1 to digital pin 3
 * ILS 2 to digital pin 2
 * LCD RS pin to digital pin 7
 * LCD Enable pin to digital pin 11
 * LCD D4 pin to digital pin 6
 * LCD D5 pin to digital pin 8
 * LCD D6 pin to digital pin 9
 * LCD D7 pin to digital pin 10
 * LCD R/W pin to ground
 * 10K resistor:
 * ends to +5V and ground
 * wiper to LCD VO pin (pin 3)
 
 Library originally added 18 Apr 2008
 by David A. Mellis
 library modified 5 Jul 2009
 by Limor Fried (http://www.ladyada.net)
 example added 9 Jul 2009
 by Tom Igoe
 modified 22 Nov 2010
 by Tom Igoe
 
 This example code is in the public domain.

 http://www.arduino.cc/en/Tutorial/LiquidCrystal
 */
/*******************************************************

 Gestion de menu – v1
 Par Yersinia Programs

 http://yersiniaprograms.wordpress.com/
 
 Note : la v0.9 permetai de sortir du tableau
 du menu pour les valeur < 0. Sera corrigé pour
 la v1.

********************************************************/

// include the library code:
#include <LiquidCrystal.h>
#include <Stepper.h>
// Définition des PIN
#define ILS_A  3     
#define ILS_B  2 



// Définition des variables
// Mémorise l'état des sorties A et B
int StateA = 0; 
int StateB = 0;
// Mémorise l'état des sorties A et B antérieures
int StateA_anterieur = 0; 
int StateB_anterieur = 0; 

int Compteur = 0;
int Compteur_anterieur = 0;
int Compteur_impulsion = 0;
int A = 0;
int B = 0;
int C = 0;
int D = 0;

int lcd_keyA4     = 0;
boolean choixmenu = 0;

float Nbspire = 0;
float Pasvis = 0.80;// Défini le pas de la tige filetée actuellement 5mm de diamètre
int Sense = 0;
int Steps = 0;

int val = 0;
int stepsMaped = 0;                   // for your motor
// Mémorise le diamètre du fil
float fFil = 0;
// Modification des settings Arduino d'origine pour améliorer la conversion
// analogique vers numérique et ainsi augmenter la vitesse de traitement
// avec ces réglages une conversion prend 24 µs
// Define various ADC prescaler
const unsigned char PS_16 = (1 << ADPS2);
const unsigned char PS_128 = (1 << ADPS2) | (1 << ADPS1) | (1 << ADPS0);

// define some values used by the panel and buttons
int lcd_key     = 0;
int adc_key_in  = 0;
int cumul_spire = 0;
int cumul_couche = 0;
int precompteur = 0;

boolean choix = 0;
int up;
int ancien_boutton;
int droit;
int select;
int valeur;
int ancienne_valeur;
int x = 0;
int y = 0;


// initialize the library with the numbers of the interface pins
LiquidCrystal lcd(7, 11, 10, 9, 8, 6);

// initialize the stepper library on pins 8 through 11:
// 48 is the number of steps per revolution,change this to fit the number of steps per revolution
// Réglage pour le moteur 55SI-25DAWC
// Brochage des fils en sortie de l'ULN2003 
// Pin 16 Rouge 55SI-25DAWC, Rose   ST35,
// Pin 15 Brun  55SI-25DAWC, Orange ST35,
// Pin 14 Jaune 55SI-25DAWC, Jaune  ST35,
// Pin 13 Bleu  55SI-25DAWC, Bleu   ST35,
Stepper myStepper(48,4,12,5,13);

// initialisation du menu
char menu_text [7][7][16] = {
{
{"Nb de spires =>"}, {"Millier      =>"}, {"Centaine     =>"},{"Dizaine     =>"}, {"Unite    "},  {"null"},        {"null"}
},  
{
{"Cumul compt  =>"}, {"Decomptage   =>"}, {"  Comptage"},      {"null"},           {"null"},      {"null"},        {"null"}
},
{
{"Spire/couche =>"}, {"Centaine     =>"},{"Dizaine     =>"}, {"Unite    "},{"Debut Gauche =>"}, {"Debut Droite"},  {"null"}
},
{
{"Guide fil    =>"}, {"+ 10 step    =>"}, {"- 10 step    =>"}, {"+ 1 step     =>"},{"- 1 step"},  {"null"},        {"null"}
},
{
{"Compteur     =>"}, {"+ en 1/10    =>"}, {"- en 1/10      "}, {"null"},           {"null"},      {"null"},        {"null"}
},
{
{"Sauvegarde   =>"}, {"Sauver       =>"}, {"Recharger      "}, {"null"},           {"null"},      {"null"},        {"null"}
},
{
{"null"},           {"null"},             {"null"},            {"null"},           {"null"},      {"null"},        {"null"}
} 
};

// Il faut mettre l’adresse de l’enregistrement des valeurs de l’EEPROM à la place des 0
// Faire une fonction de parcours de tableau et de chargement des valeurs
// Puis faire un enregistrement directement dans l’EEPROM grace au tableau qui donnera
// l’adresse de la case mémoire utilisé
int menu_valeur [7][7][3] = {
{
{-10},  {0}, {0}, {0},  {0},  {-1},{-1}
},  
{
{-11},{-2}, {-3}, {-1}, {-1}, {-1},{-1}
},
{
{-12}, {0},  {0},  {0}, {-4}, {-5},{-1}
},
{
{-1}, {-6}, {-7}, {-3}, {-2}, {-1},{-1}
},
{
{-1}, {-8}, {-9}, {-1}, {-1}, {-1},{-1}
},
{
{-1},{-13},{-14}, {-1}, {-1}, {-1},{-1}
},
{
{-1}, {-1}, {-1}, {-1}, {-1}, {-1},{-1}
}
};
#define btnRIGHT  0
#define btnUP     1
#define btnDOWN   2
#define btnLEFT   3
#define btnSELECT 4
#define btnNONE   5

void setup() {
  // set up the LCD's number of columns and rows: 
  lcd.begin(16, 2);
  // Print a message to the LCD.
  // lcd.print("Compteur");
  // Initialise les entrées A et B de l'encodeur
  pinMode(ILS_A, INPUT); 
  pinMode(ILS_B, INPUT);
  // set up the ADC
  ADCSRA &= ~PS_128;  // remove bits set by Arduino library
  // you can choose a prescaler from above.
  // PS_16, PS_32, PS_64 or PS_128
  ADCSRA |= PS_16;    
  // set our own prescaler to 16 
  // set the speed at 300 rpm:
  myStepper.setSpeed(300);
    
}

void loop() {
  
  Selection();
  
  if (choixmenu == 1)
    {
           
    Comptage();
    
    Compteimpulsion();
    
    AfficheCompteur();
    
    Diamfil();
    
    AfficheDiamFil();
    
    Gestionstep();
        
    Avanceguidefil();
           
    }
    
  if (choixmenu == 0)
    {
    Gestionboutons ();
    }
   
   
}


// Fonction de comptage
void Comptage()
{
    // Lecture des sorties A et B de l'encodeur. Avant chaque lecture,
  // mémorisation de l'état antérieur de chaque broche. Ce principe permet
  // la détection d'un front montant.
  StateA_anterieur= StateA;
  StateA = digitalRead(ILS_A);
  StateB_anterieur= StateB;  
  StateB = digitalRead(ILS_B);

  // Détection du front montant :
  // Etat actuel : haut, état antérieur : bas
  if ((StateA == HIGH) && (StateA_anterieur == LOW)) { 
    if (StateB == LOW) {
      Sense = 1;      
      }
    
    };  

  // Détection du front montant :
  // Etat actuel : haut, état antérieur : bas
  if ((StateB == HIGH) && (StateB_anterieur == LOW)) { 
    if (StateA == LOW) {
      Sense = -1;      
      };    
    }
}

// Fonction comptage des impulsions
void Compteimpulsion()
{
  A = abs(Compteur_impulsion);
  
  if (A<10)
  {
   Compteur_impulsion = Compteur_impulsion + Sense;
  }
  else 
  {
   Compteur_impulsion = 0;
  } 

}

// Fonction d'affichage du compteur
void AfficheCompteur()
{
  Compteur = Compteur + Sense;
  Nbspire=Compteur*0.1;
  // set the cursor to column 12, line 0
  // (note: line 1 is the second row, since counting begins with 0):
  lcd.setCursor(0,0);
  lcd.print("Compteur   ");
  lcd.setCursor(11,0);
  // reset the screen:
  lcd.print("    ");
  // set the cursor to column 12, line 0
  lcd.setCursor(11,0);
  lcd.print(Nbspire,1); 
  //lcd.print(Compteur_impulsion);
}

// Fonction de paramétrage du diamètre du fil
void Diamfil()
{
  val=analogRead(A3);
  stepsMaped=map(val, 0, 1023, 0, 1008);
      
  // Doit etre calculé par rapport à la tige filetée 
  // 1 tour de tige filetée en pas de 1 revient à une avance de 1 mm
  // Soit 1/48 (par rapport au moteur)steps fois le nombre de steps d'avance
  // pour faire 1 tour complet du motoréducteur 
  fFil = stepsMaped*Pasvis*0.002083333;
}
// Fonction d'affichage du diamètre du fil
void AfficheDiamFil()
{
  // set the cursor to column 0, line 1
  // (note: line 1 is the second row, since counting begins with 0):
  lcd.setCursor(0,1);
  // print the number of seconds since reset:
  lcd.print("Diam fil");
  // set the cursor to column 0, line 1
  // (note: line 1 is the second row, since counting begins with 0):
  lcd.setCursor(11,1);
  lcd.print(fFil,3); 
}

// Fonction D'avance du guide fil 
void Avanceguidefil()
{
  // revolution  in one direction or the other:
  Steps = (Sense*B);
  myStepper.step(Steps);
  Sense = 0;
  B = 0;
  C = 0;
  D = 0;
}

// Fonction de gestion de la découpe du nombre de steps pour 
// remplir une révolution de la broche principale au step près
void Gestionstep()
{
 if ( A <= 7 )
    {
      B = int(stepsMaped*0.01);
    }
    else if ( A == 8 )
    {
      C = int((stepsMaped*0.1)-(int(stepsMaped*0.01)*8));
      B = int(C*0.5);
    }
    else if ( A == 9 )
    {
      C = int(int((stepsMaped*0.1)-(int(stepsMaped*0.01)*8))*0.5);
      D = (int(stepsMaped*0.01))*8;
      B = ((int(stepsMaped*0.1))-D)-C;            
    } 
}

// Fonction pour entrer ou sortir du menu
int Selection()
{
  lcd_keyA4 = digitalRead(A4);
  if (lcd_keyA4 == HIGH)
  {
    delay(100); // delay to debounce switch
    choixmenu = !choixmenu;
  }
    delay(100);
  
}

// Partie qui gère l'affichage du menu


// Fonction qui gère la lecture des boutons et qui retourne 
// le bouton appuyés
int Lecture_LCD_bouttons()
{
adc_key_in = analogRead(A5);      // read the value from the sensor
// my buttons when read are centered at these valies: 0, 144, 329, 504, 741
// we add approx 50 to those values and check to see if we are close
if (adc_key_in > 1000) return btnNONE; // We make this the 1st option for speed reasons since it will be the most likely result
lcd.setCursor(0,0);
//lcd.print(adc_key_in);
// For V1.0 us this threshold
if (adc_key_in < 50)   return btnRIGHT;
if (adc_key_in > 150 && adc_key_in < 250)  return btnUP;
if (adc_key_in > 375 && adc_key_in < 475)  return btnDOWN;
if (adc_key_in > 565 && adc_key_in < 665)  return btnLEFT;
if (adc_key_in > 795 && adc_key_in < 895)  return btnSELECT;

}

// Fonction gestion des retours boutons
void Gestionboutons ()
{
 lcd_key = Lecture_LCD_bouttons();
 if (ancien_boutton != lcd_key) // permet d’in/décrémenter que de 1 lors de l’appuie d’un bouton
 {
 switch (lcd_key)
 {
 case btnRIGHT:
 {
 if (choix == 0)
 {
 if (droit < 6)
 {
 droit++;
 }
 else 
 {
 droit=0; 
 }
 }
 
 if (choix == 1)
 {
 if (valeur <= 8)
 {
   valeur++;
 }
 else
 {
   valeur = 0;
 }  
 }
 }
 
 break;
 

 case btnLEFT:
 {
 if (choix == 0)
 {
 if (droit > 0) 
 {
 droit--;
 }
 else
 { }
 }
 if (choix == 1)
 {
 if (valeur >= 1)
 {
   valeur--;
 }
 else
 {
   valeur = 9;
 }  
 }
 }
 
 break;

 case btnUP:
 {
 if (up < 6)
 {
 up++;
 }
 else 
 {
 up=0; 
 }
 }
 
 break;

 case btnDOWN:
 {
 if (up > 0) 
 {
 up--;
 }
 else
 { }
 }
 
 break;

 case btnSELECT:
 {
 delay(100); // delay to debounce switch
 choix = !choix;
 }
 break;

 case btnNONE:
 { }
 
 break;
 
 }
 ancien_boutton = lcd_key;
 }
 if (strcmp(menu_text[up][droit], "null") == 0) // le test pour savoir si il y a un sous menu
 {
 droit = 0;
 up =0;
 } 
 else
 {
 lcd.setCursor(0,0);
 lcd.print(menu_text[up][droit]);
 }
 lcd.setCursor(0,1);
 lcd.print(up);
 lcd.setCursor(1,1);
 lcd.print(droit);
 lcd.setCursor(2,1);
 lcd.print(choix);
 lcd.setCursor(3,1);
 lcd.print(" ");
 lcd.setCursor(4,1);
 lcd.print(valeur);
 lcd.setCursor(5,1);
 lcd.print("           ");

}



